<?php

// Math test
function average(array $values)
{
  return array_sum($values) / count($values);
}
$mspeed = 0;
for ($i = 30 ; $i ; $i--)
{
  $t = hrtime(true) + 1000000000;
  $mresult = 1;
  for ($j = 0 ; hrtime(true) < $t ; $j++)
  {
    $a = $mresult + 0.123456;
    $b = $mresult - 0.987654;
    $c = $mresult * 0.456789;
    $d = $mresult / 0.654321;
    $e = average([$a, $b]);
    $f = average([$c, $d]);
    $mresult = array_sum([min($e, $f), max($e,$f)]) / 2 ;
  }
  echo "$i: Math result: $mresult\n";
  echo "$i: Math speed: $j cycles/second\n";
  $mspeed = ($j > $mspeed) ? $j : $mspeed;
}

// Text test
$tspeed = 0;
for ($i = 30 ; $i ; $i--)
{
  $t = hrtime(true) + 1000000000;
  $tresult = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789ěščřžýáíéúůďťň";
  for ($j = 0 ; hrtime(true) < $t ; $j++)
  {
    $a = mb_substr($tresult, 0, 15);
    $b = mb_substr($tresult, -15, 15);
    $c = mb_substr($tresult, 15, 20);
    $d = mb_strtolower($a);
    $e = mb_strtoupper($b);
    $f = implode("\r", [$e, $d, $c]);
    $tresult = str_replace("\r", "", $f);
  }
  echo "$i: Text result: $tresult\n";
  echo "$i: Text speed: $j cycles/second\n";
  $tspeed = ($j > $tspeed) ? $j : $tspeed;
}

echo "\nBest math speed: $mspeed cycles/second\n";
echo "Best text speed: $tspeed cycles/second\n";