import time
from statistics import mean

# Math test
mspeed = 0
for i in range(30, 0, -1):
    t = time.time() + 1
    mresult = 0
    j = 0
    while time.time() < t:
        a = mresult + 0.123456
        b = mresult - 0.987654
        c = mresult * 0.456789
        d = mresult / 0.654321
        e = mean([a, b])
        f = mean([c, d])
        mresult = sum([min(e, f), max(e, f)]) / 2
        j += 1
    print(f"{i}: Math result: {mresult}")
    print(f"{i}: Math speed: {j} cycles/second")
    mspeed = mspeed if mspeed > j else j

# Text test
tspeed = 0
for i in range(30, 0, -1):
    t = time.time() + 1
    tresult = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789ěščřžýáíéúůďťň"
    j = 0
    while time.time() < t:
        a = tresult[:15]
        b = tresult[-15:]
        c = tresult[15:35]
        d = a.lower()
        e = b.upper()
        f = "\r".join([e, d, c])
        tresult = f.replace("\r", "")
        j += 1
    print(f"{i}: Text result: {tresult}")
    print(f"{i}: Text speed: {j} cycles/second")
    tspeed = tspeed if tspeed > j else j

print("")
print(f"Best math speed: {mspeed} cycles/second")
print(f"Best text speed: {tspeed} cycles/second")
